use quick_xml::{Reader, Writer};
use tokio::{
    io::{BufReader, ReadHalf, WriteHalf},
    net::TcpStream,
};
use tokio_rustls::server::TlsStream;

pub struct TLSStream {
    reader: Reader<BufReader<ReadHalf<TlsStream<TcpStream>>>>,
    writer: Writer<WriteHalf<TlsStream<TcpStream>>>,
    buffer: Vec<u8>,
    hostname: String,
}

impl TLSStream {
    pub fn new(conn: TlsStream<TcpStream>, hostname: String) -> Self {
        let (read, write) = tokio::io::split(conn);
        let (reader, writer) = (
            Reader::from_reader(BufReader::new(read)),
            Writer::new(write),
        );

        Self {
            reader,
            writer,
            hostname,
            buffer: vec![],
        }
    }

    pub async fn start_stream(self) {}
}
